﻿Imports System.IO
Imports System.Linq
Imports Telerik.Windows.Zip
 
Module ZipFile

    <System.Runtime.CompilerServices.Extension> _
    Public Shared Sub ExtractToDirectory(source As ZipArchive, destinationDirectoryName As String)
        If source Is Nothing Then
            Throw New ArgumentNullException("source")
        End If

        If destinationDirectoryName Is Nothing Then
            Throw New ArgumentNullException("destinationDirectoryName")
        End If

        Dim fullName As String = Directory.CreateDirectory(destinationDirectoryName).FullName

        For Each entry As ZipArchiveEntry In source.Entries
            Dim fullPath As String = Path.GetFullPath(Path.Combine(fullName, entry.FullName))
            If Not fullPath.StartsWith(fullName, StringComparison.OrdinalIgnoreCase) Then
                Throw New IOException("Extracting results in outside")
            End If

            If Path.GetFileName(fullPath).Length <> 0 Then
                Directory.CreateDirectory(Path.GetDirectoryName(fullPath))
                entry.ExtractToFile(fullPath, False)
            Else
                If entry.Length <> CLng(0) Then
                    Throw New IOException("Directory name with data")
                End If
                Directory.CreateDirectory(fullPath)
            End If
        Next
    End Sub

    <System.Runtime.CompilerServices.Extension> _
    Public Shared Sub ExtractToFile(source As ZipArchiveEntry, destinationFileName As String, overwrite As Boolean)
        If source Is Nothing Then
            Throw New ArgumentNullException("source")
        End If

        If destinationFileName Is Nothing Then
            Throw New ArgumentNullException("destinationFileName")
        End If

        Using fileStream As Stream = File.Open(destinationFileName, If(overwrite, FileMode.Create, FileMode.CreateNew), FileAccess.Write, FileShare.None)
            Using entryStream As Stream = source.Open()
                entryStream.CopyTo(fileStream)
            End Using
        End Using

        File.SetLastWriteTime(destinationFileName, source.LastWriteTime.DateTime)
    End Sub
End Module
